<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <div v-if="subs.length > 0">

                <div class="form row justify-center q-pa-md">
                    <div class="col-12 col-lg-4">
                        <div class="column">
                            <div class="text-h5 text-weight-light">
                                Please choose a SubContractor
                            </div>
                            <q-select label="Pick a SubContractor"
                                      v-model="routeQueries.sub"
                                      filled
                                      emit-value
                                      label-slot
                                      option-label="name"
                                      option-value="id"
                                      map-options
                                      :options="subs"
                            />
                        </div>
                    </div>
                </div>

                <div class="form row justify-center q-pa-md" v-if="routeQueries.sub !== ''">
                    <Form class="col-12 col-lg-4"
                          @unknown="SubmitError"
                          @auth="SubmitError"
                          title='Create Worker'
                          :fields="fields"
                          v-model="models"
                          :onSubmit="Submit"
                          @success="SubmitSuccess">
                        <template v-slot:nameAppend>
                            <div class="col-3">
                                <div class="row justify-end">
                                    <AvatarPicker v-model="image" title="Create Worker"/>
                                </div>
                            </div>
                        </template>


                    </Form>
                </div>
            </div>
            <div v-else>
                <Container :max-height="1" class="row  justify-center">
                    <div class="col-lg-6 col-12">
                        <div style="height: 100%;" class="column justify-center">
                            <LottieAnimation :data="$animations.emptyBox" :loop="false" style="height: 70%;"/>
                            <q-btn :to="`/subcontractor/create`" color="primary"> Create One
                            </q-btn>
                        </div>
                    </div>

                </Container>
            </div>
        </DocumentWrapper>

    </q-page>

</template>

<style lang='scss' scoped>
.body--light {
    .image-uploader {
        background: #FFF;
    }
}

.body--dark {
    .image-uploader {
        background: $dark;
    }

    .dark-fab {
        background: #232323;
    }
}
</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Form from "components/Form.vue";
import LabelSlot from "components/LabelSlot.vue";
import ImageUploader from "components/Core/ImageUploader.vue";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {SubContractorPrincipalResponse} from "src/classLibrary/APIModels/core/subContractorPrincipalResponse";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import LottieAnimation from "components/Core/LottieAnimation.vue";
import {WorkerResponse} from "src/classLibrary/APIModels/core/workerResponse";
import {Err} from "@hqoss/monads";
import {ApiError, ApiObjectError} from "src/classLibrary/Core/Api";
import {TagResponse} from "src/classLibrary/APIModels/core/tagResponse";
import Container from "components/Core/Container.vue";
import {StandardDotNetError} from "src/classLibrary/Core/Standard";

import {FormInput, SelectInput} from "src/classLibrary/FormTypes";
import AvatarPicker from "components/Core/AvatarPicker.vue";


@Component({
    components: {
        AvatarPicker,
        Container, LottieAnimation, AnimationComponent, DocumentWrapper, ImageUploader, LabelSlot, Form
    }
})
export default class CreateWorker extends Vue {

    routeQueries = {
        sub: ''
    }
    subs: SubContractorPrincipalResponse[] = []

    async loadSubContractors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<SubContractorPrincipalResponse[]>(`SubContractor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.subs = o;

            }
        })

    }

    async loadTags() {
        const p = this;
        const pid = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get(`Worker/trades/${pid}`, null, token);
        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                (this.fields[2] as SelectInput).options = o;
            }
        })
    }

    async mounted() {
        await this.loadSubContractors();
        await this.loadTags();

    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    SubmitError(e: ApiError) {
        this.Wrap.SubmitError(e);
    }

    async TagExist(t: string): Promise<boolean> {
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get(`Tag/${t}`, null, token);
        return r.isOk();
    }

    async Submit(_: any) {
        const token = await this.$auth.CoreToken;
        const i = this.image === '' ? GenerateAvatar(this.models.models.name) : this.image;


        const exist = await this.TagExist(this.models.models.mac);
        const e: StandardDotNetError = {
            type: '',
            title: '',
            status: 400,
            tradeId: '',
            errors: {
                tag: ['Tag already exist. Please link this tag separately']
            },
        }
        const dotnetMock: ApiObjectError = {
            code: 400,
            error: e,
        }
        if (exist) return Err(ApiError.Object(dotnetMock));

        const tr = await this.$coreApi.Post<TagResponse>(`Tag/${this.PersistentStore.StoreValue.project}`,
            {
                mac: this.models.models.mac,
                labels: []
            }, token);
        if (tr.isErr()) return tr;

        const r = await this.$coreApi.Post<WorkerResponse>(`Worker/${this.PersistentStore.StoreValue.project}/${this.routeQueries.sub}`, {
            name: this.models.models.name,
            trade: this.models.models.trades,
            image: i,
            data: {}
        }, token);
        if (r.isErr()) {
            const dtr = await this.$coreApi.QDelete(`Tag/${this.models.models.mac}`, null, token);
            if (dtr.isSome()) {
                this.$q.notify({
                    icon: 'icofont-warning',
                    color: 'warning',
                    message: 'Failed to delete tag created before worker creation attempt'
                })
                console.error(dtr.unwrap())
            }
            return r;
        }
        const wid = r.unwrap().principal.id;
        const mac = tr.unwrap().tag.macAddress;

        // Add Tag
        const fr = await this.$coreApi.QPost(`Tag/${mac}/add/${wid}`, null, token)
        if (fr.isSome()) return Err(fr.unwrap());
        return r;

    }

    async SubmitSuccess(a: WorkerResponse) {
        this.$q.notify({
            color: 'positive',
            message: `Successfully created subcontractor ${a.principal.name}`,
            icon: 'check'
        });
        await this.$router.push(`/subcontractor/${this.routeQueries.sub}/workers`);
    }


    image = '';
    models = {
        valid: false,
        models: {
            trades: [],
            name: '',
            mac: '',
        }
    }

    fields: FormInput[] = [
        {
            rules: [
                (v: string) => !!v || 'Please enter the Construction Worker\'s name',
                (v: string) => (v.length < 128 && v.length > 1) || 'Worker\'s name has to be between 2 to 128 characters',
            ],
            label: 'Worker Name',
            tooltip: "Name of the Construction worker",
            icon: 'icofont-worker',
            key: 'name',
            max: 128,
            baseType: 'basic',
            type: 'text',
        },
        {
            rules: [
                (v: string) => !!v || 'Please enter the Construction Worker\'s tag',
                (v: string) => (v.length < 128 && v.length > 1) || 'Worker\'s tag has to be between 2 to 128 characters',
            ],
            label: 'Worker Tag',
            tooltip: "Tag of Worker",
            icon: 'label',
            key: 'mac',
            max: 128,
            baseType: 'basic',
            type: 'text',
        },
        {
            label: 'Trades',
            icon: 'build',
            tooltip: 'Construction Worker\'s trades',
            chip: true,
            multiple: true,
            key: 'trades',
            baseType: 'select',
            options: [],
            newValueMode: 'add-unique'
        }
    ]

}
</script>
